#ifndef Map_H
#define Map_H

#include <Random.h>
#include <Textur2D.h>
#include "Data.h"
#include "../../../Include/KSGKlientV.h"

using namespace Framework;

class Map : public GameData
{
private:
    LRahmen *kam;
    LRahmen *map;
    Datei capture;
    MinigameKlientV *klient;
    Textur2D *flammenM;
    Textur2D *flammenL;
    Textur2D *flammenR;
    Bild **aTextur;
    Bild **sTextur;

    Asteroid *createNewAsteroid() override;
public:
    // Konstruktor
    Map( MinigameKlientV *klient );
    // Destruktor
    ~Map();
    // nicht constant
    void reset( Text *zOptionen ) override;
    void doMausEreignis( MausEreignis &me );
    void doTastaturEreignis( TastaturEreignis &te );
    bool tick( double t ) override;
    void render( Bild &zRObj );
    void speichern();
};

#endif