#ifndef Ship_H
#define Ship_H

#include <Model2D.h>
#include <Datei.h>

using namespace Framework;

class Schuss;
class Asteroid;

class Ship
{
private:
	Model2D *ship;
	Vec2< float > pos;
	Vec2< float > speed;
    Vertex stL;
    Vertex kL;
    Vertex stR;
    Vertex kR;
    Vertex stM;
    Vertex kM;
    float rSpeed;
	int ref;

public:
	// Konstruktor
	Ship( Model2DData *data, Vec2< float > p, Vec2< float > s, float r );
	// Destruktor
	~Ship();
	// nicht constant
    void setTexture( Textur2D *zFlammenM, Textur2D *zFlammenL, Textur2D *zFlammenR, Bild *textur );
    void setPRS( Vec2< float > p, Vec2< float > s, float r, float rSpeed );
	bool tick( double zeit, int breite, int hhe, char tastenStnde );
	void render( Bild &zRObj );
	// constant
	void save( Datei *zD ) const;
	Schuss *getSchuss() const;
	bool istTod( Asteroid *zA ) const;
	Punkt getKamPos( int breite, int hhe ) const;
	Punkt getPos() const;
	// Reference Counting
	Ship *getThis();
	Ship *release();
};

#endif